
#include <Process.au3>
#Include <Array.au3>

#cs

TranzVoo is based on one of my "glosslookup" scripts.  Those scripts helped translators look up terms in a glossary.  The TranzVoo also looks up "terms" in what might be called a glossary, but the current script checks only for exact matching "terms".

#ce

Global $fileopenhtml, $glossaryfilecolumns, $glossaryfilelines, $glossaryfileopen, $glossaryfileopendialog, $glossaryfileread, $grabbedtext, $grabbedword, $grabbedwordarray, $htmloutput, $i, $j, $k, $l, $output, $found

MsgBox (0, "TranzVoo v1", "TranzVoo looks up strings in a mini-TM, for use with TransView from TranSolution.  Read the instructions in the readme.txt file." & @CRLF & @CRLF & "Shortcuts:" & @CRLF & @CRLF & "Ctrl + Num-plus = find translation and paste it into the current cell" & @CRLF & "Ctrl + Num-minus = find translation and keep it in clipboard" & @CRLF & "WinKey + Q = Exit the program (or right-click its icon)", 0)

HotKeySet("^{NUMPADADD}", "seekandpaste")
HotKeySet("^{NUMPADSUB}", "seekandkeep")

HotKeySet("#q", "exitty")

#cs
$glossaryfileopendialog = FileOpenDialog ("Select mini-TM", @ScriptDir, "Text files (*.txt)|All files (*.*)") ; uncomment this to be asked for glossary at start of run
#ce

; #cs
$glossaryfileopendialog = @ScriptDir & "\mini-TM.txt" ; comment this if you uncomment the above
; #ce

$glossaryfileopen = FileOpen ($glossaryfileopendialog, 128) ; 128 means UTF8, 32 means UTF16LE
$glossaryfileread = FileRead ($glossaryfileopen)

$glossaryfilelines = StringSplit ($glossaryfileread, @CRLF, 3)

Global $glossaryfilefirstcolumn[UBound ($glossaryfilelines)]
Global $glossaryfilesecondcolumn[UBound ($glossaryfilelines)]

For $i = 0 to UBound ($glossaryfilelines) - 1
$glossaryfilecolumns = StringSplit ($glossaryfilelines[$i], @TAB, 3)
If UBound ($glossaryfilecolumns) = 2 Then ; i.e. if there is 2 columns in the line
$glossaryfilefirstcolumn[$i] = $glossaryfilecolumns[0]
$glossaryfilesecondcolumn[$i] = $glossaryfilecolumns[1]
EndIf
Next

; MsgBox (0, "", _ArrayToString($glossaryfilefirstcolumn, " | "), 0) ; If you want to check that the entire glossary was read
; MsgBox (0, "", _ArrayToString($glossaryfilesecondcolumn, " | "), 0) ; If you want to check that the entire glossary was read

While 1
Sleep ("100")
WEnd

Func exitty ()
Exit
EndFunc

Func seekandpaste ()

Send ("+{TAB}")
Send ("^c")
$grabbedtext = ClipGet()

$output = ""
$found = 0

For $m = 0 to UBound ($glossaryfilelines) - 1

If $found = 0 Then
If $grabbedtext = $glossaryfilefirstcolumn[$m] Then
$output = $glossaryfilesecondcolumn[$m]
$found = 1
EndIf
EndIf

Next

If $found = 0 Then
MsgBox (0, "No translation found!", "TransVoo could not find a translation for [" & $grabbedtext & "].", 0)
Send ("{TAB}")
Else
ClipPut ($output)
Send ("{TAB}")
Send ("^v")
EndIf

EndFunc

Func seekandkeep ()

Send ("+{TAB}")
Send ("^c")
$grabbedtext = ClipGet()

$output = ""
$found = 0

For $m = 0 to UBound ($glossaryfilelines) - 1

If $found = 0 Then
If $grabbedtext = $glossaryfilefirstcolumn[$m] Then
$output = $glossaryfilesecondcolumn[$m]
$found = 1
EndIf
EndIf

Next

If $found = 0 Then
MsgBox (0, "No translation found!", "TransVoo could not find a translation for [" & $grabbedtext & "].", 0)
Send ("{TAB}")
Else
ClipPut ($output)
ToolTip ("[" & $output & "] is on the clipboard")
Send ("{TAB}")
EndIf

EndFunc

